package Get_params;
#
#

use strict;


sub open
{
  my ($pkg) = @_;
  my %params = $pkg->get_params();
  return (bless{params=>\%params}, $pkg);
}


sub get_params
{
   my $pkg = shift;
   my %form;
   # Get the input
   my $buffer;
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   $buffer=$ENV{'QUERY_STRING'}.'&'.$buffer;
   # Split the name-value pairs;
   my @pairs = split(/&/, $buffer);
   foreach my $pair (@pairs) 
   {
     my ($name, $value) = split(/=/, $pair);
     $value =~ tr/+/ /;
     $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
     $form{$name} = $value;
   }
    if ($form{dir})
    {
        $form{dir} .='/';
        $form{dir} =~ s/\/\/$/\//;
    }
    return (%form);
}

sub get
{
  my ($obj, $key) = @_;
  return $obj->{params}->{$key};
}


1;
